# Standard backing services for DeMi (detector microservices)
# see also: https://12factor.net/backing-services
#
# portainer and traefik are special because they manage / proxy all other services
# (they are also optional)
#
# see also:
# https://github.com/portainer/portainer-compose/blob/master/traefik/docker-compose.yml
#
# 2022 G. Brandt <gbrandt@cern.ch>

# ignored by compose but not by third-party tools ...
version: "3.9"

# name: demi

x-base:
  &base
  restart: always
  networks:
    - demi

networks:
  demi:
    name: ${DEMI_NET}
    external: true

volumes:
  portainer_data:

services:
  portainer_agent:
    <<: *base
    image: registry.cern.ch/docker.io/portainer/agent:latest
    container_name: portainer_agent
    environment:
      # REQUIRED: Should be equal to the service name prefixed by "tasks." when
      # deployed inside an overlay network
      # AGENT_CLUSTER_ADDR: agent
      # AGENT_PORT: 9001
      LOG_LEVEL: DEBUG
    ports:
      - 9001:9001
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
      - /var/lib/docker/volumes:/var/lib/docker/volumes
    # healthcheck:
    #   test: "wget --no-verbose --tries=1 --spider http://localhost:9001 || exit 1"

  portainer:
    <<: *base
    image: registry.cern.ch/docker.io/portainer/portainer-ce:latest
    container_name: portainer
    # command:
    # - "-H tcp://agent:9001"
    # - --tlsskipverify
    # - --admin-password-file=/tmp/admin-password
    # - --http-enabled
    # - --base-url="/portainer"
    # user: ${PUID}:${PGID}
    # environment:
    #   - PUID
    #   - PGID
    #   - TZ
    ports:
      # 8000 only needed for Edge agents
      # - 8000:8000
      - 9000:9000
      - 9443:9443
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
      - portainer_data:/data
      # - ${DOCKER_DIR}/portainer:/data
      # - ./admin-password:/tmp/admin-password
    labels:
      - ${DEMI_NAMESPACE}.portainer.host=${HOST}
      #- ${DEMI_NAMESPACE}.portainer.url=http://${HOST}:9000
      - ${DEMI_NAMESPACE}.portainer.hostport=9000
      - ${DEMI_NAMESPACE}.portainer.category=Tools
      - ${DEMI_NAMESPACE}.portainer.description=UI for container management
      - traefik.http.routers.portainer.rule=Host(`${HOST}`) && PathPrefix(`/portainer`)
      - traefik.http.middlewares.portainer_stripprefix.stripprefix.prefixes=/portainer
      - traefik.http.routers.portainer.middlewares=portainer_stripprefix@docker
      # - traefik.http.routers.portainer.entrypoints=http
      # - traefik.http.services.portainer.loadbalancer.server.scheme=http
      - traefik.http.services.portainer.loadbalancer.server.port=9000
      # healthcheck:
      #   test: "wget --no-verbose --tries=1 --spider http://localhost:9000 || exit 1"
      #   interval: 60s
      #   timeout: 5s
      #   retries: 3
      #   start_period: 20s
